ProjOpenCoastS/urls.py
from django.conf.urls import url, include
from django.contrib import admin


urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^auth/', include('django_auth_oidc.urls')),
    url(r'^i18n/', include('django.conf.urls.i18n')),
    url(r'^', include('front.urls')),
    url(r'^wizard/', include('wizard.urls')),
    url(r'^viewer/', include('viewer.urls')),

    url(r'^raster/', include('raster.urls')),
    url(r'^satellite/', include('satellite.urls')),
]

handler400 = 'front.views.handler400'
handler403 = 'front.views.handler403'
handler404 = 'front.views.handler404'
handler500 = 'front.views.handler500'

front/urls.py
from django.conf.urls import url
from .views import *
from django.views.generic import TemplateView

# TODO: when there is more than one app: point to views inside 'front' redirecting to the app selected by the user
from wizard.views import deployments, new_deploy, view_deploy, open_deploy, clone_deploy, deactivate_deploy, \
    reactivate_deploy, delete_deploy, extend_deploy, view_extend_deploys, get_file, get_definition, print_deploy, \
    get_deploys, get_boundaries


urlpatterns = [
    url(r'^$', home, name='home'),
    url(r'^home/$', home, name='home'),
    url(r'^login/$', Login.as_view(), name='login'),
    url(r'^logout/$', logout_user, name='logout'),
    url(r'^register/$', register, name='register'),
    url(r'^register/confirm/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', register_confirm, name='register_confirm'),
    url(r'^profile/$', profile, name='profile'),
    url(r'^disclaimer/$', disclaimer, name='disclaimer'),

    url(r'^ratings/$', rate_service, name='rate_service'),

    url(r'^password/change/$', password_change, name='password_change'),
    url(r'^password/recover/$', password_recover, name='password_recover'),
    url(r'^password/recover/confirm/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', password_recover_confirm, name='password_recover_confirm'),

    url(r'^userprofile/activate/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', userprofile_activate, name='userprofile_activate'),
    url(r'^activate_user/(?P<username>[\w.%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,4})/$', activate_user, name='activate_user'),

    url(r'^login_egi/$', login_egi, name='login_egi'),
    url(r'^login_egi/complete/$', login_egi_complete, name='login_egi_complete'),
    url(r'^logout_egi/$', logout_egi, name='logout_egi'),

    url(r'^deployments/$', deployments, name='deployments'),
    url(r'^deployments/new/$', new_deploy, name='new_deploy'),
    url(r'^deployments/view/(?P<deploy_id>[0-9]+)/$', view_deploy, name='view_deploy'),
    url(r'^deployments/open/(?P<deploy_id>[0-9]+)/$', open_deploy, name='open_deploy'),
    url(r'^deployments/clone/(?P<deploy_id>[0-9]+)/$', clone_deploy, name='clone_deploy'),
    url(r'^deployments/deactivate/(?P<deploy_id>[0-9]+)/$', deactivate_deploy, name='deactivate_deploy'),
    url(r'^deployments/reactivate/(?P<deploy_id>[0-9]+)/$', reactivate_deploy, name='reactivate_deploy'),
    url(r'^deployments/delete/(?P<deploy_id>[0-9]+)/$', delete_deploy, name='delete_deploy'),
    url(r'^deployments/extend/$', extend_deploy, name='extend_deploy'),
    url(r'^deployments/view_extends/$', view_extend_deploys, name='view_extend_deploys'),
    url(r'^deployments/get_deploys/$', get_deploys, name='get_deploys'),
    url(r'^deployments/get_definition/(?P<name>[[\w\-]+)/$', get_definition, name='get_definition'),
    url(r'^deployments/get_definition/(?P<name>[[\w\-]+)/(?P<action>[[\w\-]+)/(?P<deploy_id>[0-9]+)$', get_definition, name='get_definition'),

    url(r'^deployments/file/(?P<action>[[\w\-]+)/(?P<deploy_id>[0-9]+)/(?P<name>[[\w\-]+)/(?P<format>[[\w\-]+)/$', get_file, name='get_file'),
    url(r'^deployments/print/(?P<deploy_id>[0-9]+)/$', print_deploy, name='print_deploy'),
    url(r'^print/$', TemplateView.as_view(template_name="front/modal/printdeploy.html"), name='print'),

    url(r'^deployments/get_boundaries/(?P<deploy_id>[0-9]+)/$', get_boundaries, name='get_boundaries'),

    url(r'^download_file/(?P<file_cat>[[\w\-]+)/(?P<file_id>[0-9]+)/$', download_file, name='download_file'),

    url(r'^run_stats/monthly_time/(?P<year>\d{4})/(?P<month>\d{2})$', monthly_run_time),
]

wizard/urls.py
from django.conf.urls import url
from .views import *
from django.conf.urls.static import static


urlpatterns = [
    url(r'^$', open_wizard, name='open_wizard'),

    url(r'^step1/$', templates[0]['function'], name='step1'),
    url(r'^step1/disclaimer/$', accept_disclaimer, name='accept_disclaimer'),
    url(r'^step1/restart/$', templates[0]['restart'], name='step1_restart'),
    url(r'^step1/get_run_periods/(?P<mv_pk>[0-9]+)/$', get_run_periods, name='get_run_periods'),
    url(r'^step2/$', templates[1]['function'], name='step2'),
    url(r'^step2/restart/$', templates[1]['restart'], name='step2_restart'),
    url(r'^step2/validate_file/$', validate_file, name='step2_validate_file'),
    url(r'^step3/$', templates[2]['function'], name='step3'),
    url(r'^step3/restart/$', templates[2]['restart'], name='step3_restart'),
    url(r'^step4/$', templates[3]['function'], name='step4'),
    url(r'^step4/restart/$', templates[3]['restart'], name='step4_restart'),
    url(r'^step5/$', templates[4]['function'], name='step5'),
    url(r'^step5/restart/$', templates[4]['restart'], name='step5_restart'),
    url(r'^step6/$', templates[5]['function'], name='step6'),
    url(r'^step6/restart/$', templates[5]['restart'], name='step6_restart'),
    url(r'^step7/$', templates[6]['function'], name='step7'),
    url(r'^step7/restart/$', templates[6]['restart'], name='step7_restart'),
    url(r'^step8/$', templates[7]['function'], name='step8'),
    # url(r'^save_steps/$', save_steps, name='save_steps'),
    # url(r'^save_step/(?P<step>[0-9]+)/$', save_step, name='save_step'),
    url(r'^save_steps/(?P<step>[0-9]+)/$', save_steps, name='save_steps'),
]

wizard/models.py
from django.db import models

# Create your models here.

wizard/views.py
import os
from django.forms.widgets import DateTimeBaseInput

from django.shortcuts import render, redirect, HttpResponse
from django.http import JsonResponse
from django.utils.translation import ugettext_lazy as _
from django.utils.text import format_lazy
from django.core.serializers import serialize

from django.contrib.auth.decorators import login_required
from django.contrib.sites.shortcuts import get_current_site
from django.forms import formset_factory

from .forms import *
from .tables import *
from .utils import *
from front.forms import ProfileRatingForm
from front.definitions import run_type_map as RUN_TYPE_MAP
from front.definitions import kind_type_map as KIND_TYPE_MAP

from .forecast_models import schism_v540 as schism

from datetime import datetime

from front.decorators import deploy_permission
from front.utils import notify_extend_deploy

from f90nml import Parser

import wiff.opencoasts.models as wiff_models

app_name = 'wizard'


@login_required(login_url='/login/')
def step_model(request):
    template, step, last_step, msg_str = templates[0]['path'], templates[0]['step'], 0, None
    step_forms, disclaimer = [], None
    step_name = 'step' + str(step)

    if 'last_step' in request.session:
        last_step = request.session['last_step']

    baroclinic_type = 'basic2d'
    waves_type = 'nowaves'
    wq_type = 'nowqtype'

    if request.method == 'POST':
        model = ModelForm(request.POST, user=request.user)

        if step_name not in request.session:
            if 'baroclinic_type' in model.data:
                baroclinic_type = model.data['baroclinic_type']

            if 'waves_type' in model.data:
                waves_type = model.data['waves_type']

            if 'wq_type' in model.data:
                wq_type = model.data['wq_type']

            # Save model selection in session key
            request.session[step_name] = {'model_pk': str(model.data['model']), 'run_period_pk': model.data['run_period'], 'baroclinic_type': baroclinic_type, 'waves_type': waves_type, 'wq_type': wq_type}

        # Create wizard key for new deployment
        # New wizard - save a unique key as session key
        if not 'wizard_key' in request.session:
            time_ref = datetime.strftime(timezone.now(), '%Y-%m-%d-%Hh%Mm%S_%fs')
            request.session['wizard_key'] = f'u{request.user.id}_{time_ref}'

        # All went well - update LAST STEP
        if not last_step:
            request.session['last_step'] = step

        # Goto step2
        return redirect(templates[step]['name'])
    else:
        # Pass request
        if step_name in request.session:
            if 'baroclinic_type' in request.session[step_name]:
                baroclinic_type = request.session[step_name]['baroclinic_type']

            if 'waves_type' in request.session[step_name]:
                waves_type = request.session[step_name]['waves_type']

            if 'wq_type' in request.session[step_name]:
                wq_type = request.session[step_name]['wq_type']

            model = ModelForm(initial={'model': request.session[step_name]['model_pk'],
                                       'run_period': request.session[step_name]['run_period_pk'],
                                       'baroclinic_type': baroclinic_type, 'waves_type': waves_type, 'wq_type': wq_type}, user=request.user)
        else:
            model = ModelForm(user=request.user)

        step_forms.append(model)

    # Add disclaimer info if user hasn't accepted terms
    if not request.user.profile.read_disclaimer:
        disclaimer = True

    # Just passing a message
    if 'msg_str' in request.session:
        msg_str = request.session['msg_str']
        request.session.pop('msg_str')

    return render(request, template, {
        'step': step,
        'msg_str': msg_str,
        'forms': step_forms,
        'disclaimer': disclaimer,
        'default_email': settings.DEFAULT_FROM_EMAIL,
        'baroclinic_type': baroclinic_type,
        'waves_type': waves_type,
        'wq_type': wq_type,
        'app': app_name,
    })


@login_required(login_url='/login/')
def step_domain(request):
    template, step, last_step, msg_str = templates[1]['path'], templates[1]['step'], 0, None
    step_forms, errors, msg = [], [], None
    step_name = 'step' + str(step)
    grid_info, grid_table, bbox, bbox_types, boundaries, boundary_types, bathymetry = None, None, [], [], [], [], []

    # If no steps - redirect
    if 'last_step' not in request.session:
        return redirect(templates[0]['name'])

    # Return Global Bounding Box only
    # Commented on 26/09/2018 - Global BBox no longer used
    #bbox_queryset = front_models.BBox.objects.filter(bbox_type=front_models.BBox.BOXTYPE_GLOBAL)
    #if bbox_queryset:
    #    bbox = serialize('geojson', bbox_queryset)
    #    bbox_types = [{'type': item.bbox_type, 'label': str(dict(front_models.BBox.BOXTYPE)[item.bbox_type]), 'color': item.color}
    #                  for item in bbox_queryset]

    max_nodes = request.user.profile.node_maxnr
    max_bytes_size = calc_maxfilesize(max_nodes)

    baroclinic_type = 'basic2d'
    waves_type = 'nowaves'
    if 'baroclinic_type' in request.session['step1']:
        baroclinic_type = request.session['step1']['baroclinic_type']

    if 'waves_type' in request.session['step1']:
        waves_type = request.session['step1']['waves_type']

    if step_name in request.session:
        boundaries = request.session[step_name]['boundaries']['geojson']
        boundary_types = request.session[step_name]['boundaries']['legend']
        if 'bathymetry' in request.session[step_name]:
            bathymetry = request.session[step_name]['bathymetry']

        selcrs = request.session[step_name]['crs']
        try:
            selcrs = front_models.CRS.objects.get(pk=selcrs).name
        except Exception:
            pass

        # Validate if Boundaries Extent is inside Global BBox and Open boundaries is inside Oceanic BBox
        # Removed restriction on 26/09/2018
        #boundariesinbbox, msg = validate_bboxes(boundaries, selcrs)
        #if not boundariesinbbox:
        #    errors.append(msg)

        # Validate if Outer Boundaries are closed
        outerboundariesclosed, msg = validate_outerboundaries(boundaries)
        if not outerboundariesclosed:
            errors.append(msg)

        if 'grid_info' in request.session[step_name]:
            grid_info = request.session[step_name]['grid_info']

    else:
        data = DataInputForm(baroclinic_type=baroclinic_type, waves_type=waves_type)
        step_forms.append(data)

    if grid_info:
        grid_table = GridTableSummary([grid_info])

    # Just passing a message
    if 'msg_str' in request.session:
        msg_str = request.session['msg_str']
        request.session.pop('msg_str')

    return render(request, template, {
        'step': step,
        'msg_str': msg_str,
        'forms': step_forms,
        'errors': errors,
        'grid_info': grid_table,
        'bbox': bbox,
        'bbox_types': bbox_types,
        'boundaries': boundaries,
        'boundary_types': boundary_types,
        'bathymetry': bathymetry,
        'max_nodes': max_nodes,
        'max_bytes_size': round(max_bytes_size / (1024 * 1024)),
        'baroclinic_type': baroclinic_type,
        'waves_type': waves_type,
        'app': app_name,
    })


@login_required(login_url='/login/')
def step_front(request):
    template, step, last_step, msg_str = templates[2]['path'], templates[2]['step'], 0, None
    step_forms, errors, bbox, bbox_types, boundaries, boundary_types, forcings_table, forcings = [], [], [], [], [], [], None, []
    step_name = 'step' + str(step)

    # If no steps - redirect
    if 'last_step' not in request.session:
        return redirect(templates[0]['name'])
    else:
        last_step = request.session['last_step']

        # Not quite at this step yet - return to step immediately next to last step
        if last_step < step - 1:
            return redirect(templates[last_step]['name'])

        runperiod_pk = request.session['step1']['run_period_pk']

        # Get simulation run type
        baroclinic_type = 'basic2d'
        waves_type = 'nowaves'
        if 'baroclinic_type' in request.session['step1']:
            baroclinic_type = request.session['step1']['baroclinic_type']

        if 'waves_type' in request.session['step1']:
            waves_type = request.session['step1']['waves_type']

        # Return Active Oceanic and Atmosphere Forcing's Bounding Boxes only
        if 'yes' in waves_type:
            bbox_queryset = front_models.BBox.objects.filter(bbox_type__in=[front_models.BBox.BOXTYPE_OCEANIC,
                                                                            front_models.BBox.BOXTYPE_ATMOSPHERE,
                                                                            front_models.BBox.BOXTYPE_WAVES]).filter(forcing_source__active=True)
        else:
            bbox_queryset = front_models.BBox.objects.filter(bbox_type__in=[front_models.BBox.BOXTYPE_OCEANIC,
                                                                        front_models.BBox.BOXTYPE_ATMOSPHERE]).filter(forcing_source__active=True)
        if bbox_queryset:
            # TODO: stabilize this workaround - condition models to selected runperiod
            try:
                runperiod = dm_models.ModelVersionRunPeriod.objects.get(id=runperiod_pk)
                if runperiod.run_period == 72:
                    bbox_queryset = bbox_queryset.exclude(forcing_source__parent__reference='prism2017')
            except Exception:
                pass

            bbox = serialize('geojson', bbox_queryset)
            bbox_types = [
                {'forcing': item.forcing_source.pk, 'label': item.forcing_source.parent_reference(), 'color': item.color} for item in bbox_queryset]

        # Get only Open Boundaries
        bids = []

wizard/templates/wizard/step_model.html
{% extends "front/base_logged.html" %}
{% load i18n %}

{% block content %}

    {% include "wizard/header.html" %}

    <div class="panel panel-default">
      <div class="panel-heading">
          <strong>{% trans "Selecionar Modelo" %}</strong>
          <div class="help">
              <button id="help_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Mais info' %}" data-title="{% trans 'Mais info' %}" data-title_alt="{% trans 'Menos info' %}">
                  <span class="glyphicon glyphicon-question-sign"></span>
              </button>
              <button id="tips_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Dicas' %}">
                  <span class="glyphicon glyphicon-info-sign"></span>
              </button>
          </div>
      </div>
      <div id="help" class="alert alert-warning cst_hide">
         {% include "wizard/help_text/step_model.html" %}
      </div>
      <div class="panel-body">
        {% blocktrans trimmed %}
          Este Assistente de Configuração tem por objetivo a montagem de um sistema de previsão em tempo real numa área à sua escolha.
          Neste passo terá de escolher o tipo de corrida, o modelo a utilizar e o periodo de tempo a prever diariamente.
          Os tipos de corrida 3D requerem permissões avançadas.
        {% endblocktrans %}
      </div>
    </div>

    {% if errors %}
    <div class="alert alert-danger">
        <ul>
            {% for error in errors %}
            <li>{{ error }}</li>
            {% endfor %}
        </ul>
    </div>
    {% endif %}

    <form class="form" method="post">{% csrf_token %}
        <strong>{% trans "Selecione tipo de corrida:" %}</strong>
        <div id="form_div">
            {% include "front/form.html" %}
        </div>
        <div class="row btnmenu">
            <div class="col-xs-6">
            </div>
            <div class="col-xs-6 text-right">
                {% if not request.session.last_step %}
                <button id="btn_submit" type="submit" name="edit" class="btn btn-primary" data-step="2" data-intro="{% trans 'E prima o botão para continuar' %}">
                    {% trans "Concluir passo" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% else %}
                <button id="btn_next" class="btn btn-default">
                    {% trans "Seguinte" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% endif %}
            </div>
        </div>
    </form>

    {% if disclaimer %}
    {% include "front/modal/disclaimer_accept.html" %}
    {% endif %}

    <script type="text/javascript">
        // Tooltips Setup (for Intro.js)
        $('#form_div').attr("data-step", 1);
        {% if not request.session.last_step %}
        $('#form_div').attr("data-intro", "{% trans 'Neste passo preencha o formulário' %}");
        {% else %}
        $('#form_div').attr("data-intro", "{% trans 'Este passo já foi concluido e não permite alterações.' %}");
        {% endif %}

        // Submit Step event
        $('#btn_submit').click(function(e){
            var flagok = true;
            var msg = '{% trans "Para continuar terá de preencher os campos obrigatórios (*)." %}';
            // Validate form
            $('.form input, .form select').each(function(){
                if ($(this).prop('required') && $(this).val() == '') {
                    flagok = false;
                    return false;
                }
            });

            if (!flagok) {
                $('#msg_str').html(msg);
                $('#divModal_msg').modal('show');
                return false;
            }
        });

        function disableWaterQualityChoice(e){
            let baroclinic_childs = document.getElementById("baroclinic_choice").getElementsByTagName('li');
            let wq_childs = document.getElementById("wq_choice").getElementsByTagName('li');

            if(baroclinic_childs[0].childNodes[0].childNodes[0].checked) {
                for(var i = 0; i < wq_childs.length; i++) {
                    var wq_child = wq_childs[i].childNodes[0].childNodes[0];

                    if(wq_child.checked)
                        wq_child.checked = false;
                }

                wq_childs[0].childNodes[0].childNodes[0].checked = true;

                for(var j = 0; j < wq_childs.length; j++)
                    wq_childs[j].childNodes[0].childNodes[0].disabled = true;
            }
            else if(baroclinic_childs[0].childNodes[0].childNodes[0].disabled) {
                for(var i = 0; i < wq_childs.length; i++)
                    wq_childs[i].childNodes[0].childNodes[0].disabled = true;
            }
            else {
                for(var i = 0; i < wq_childs.length; i++)
                    wq_childs[i].childNodes[0].childNodes[0].disabled = false;
            }
        }

        // On Document Ready
        $(function(){
            {% if disclaimer %}
            $('#divModal_disclaimer_accept').modal();
            {% endif %}

            // Accept Disclaimer action
            $('#btn_disclaimer').click(function(e){
                $.ajax({
                    type: 'GET',
                    url: '{% url 'wizard:accept_disclaimer' %}',
                    success: function(data) {
                        if (data["done"]) {
                            // Show Tips
                            intro.start();
                        }
                    },
                    error: function(e, x, r) {
                        console.log(r + ' - ' + e);
                    }
                });
                e.preventDefault();
            });

            // Fill Periods Select according to chosen Model
            $("#id_model").change(function(e) {
                if ($(this).val()) {
                    //Fill Periods from ModelVersion selection
                    $.ajax({
                        type: 'GET',
                        url: '{% url 'wizard:get_run_periods' mv_pk=0 %}'.replace(/0/, $(this).val()),
                        success: function(response) {
                            // Remove all options except empty
                            $('select[name=run_period] option').each(function() {
                                if ($(this).val() != "") $(this).remove();
                            });

                            // Add new options if any
                            var data = response['data'];
                            for (i=0; i<data.length; i++) {
                                $('select[name=run_period]').append(
                                    $('<option>', {
                                        value: data[i].value,
                                        text: data[i].text
                                    }, '</option>')
                                );
                            }

                            // Allow changing values
                            $('#id_run_period').removeAttr("disabled");
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                        }
                    });
                } else {
                    // Remove options not in the returned data (all periods are loaded on server-side on init)
                    $('select[name=run_period]').val('');
                    // Disallow changing values
                    $('#id_run_period').attr("disabled", "");
                }
                e.preventDefault();
            });
            disableWaterQualityChoice(document.getElementById("baroclinic_choice"));
        });
    </script>
{% endblock content %}

wizard/templates/wizard/steps.html
{% load i18n %}

{% block content %}

    <div class="row bs-wizard">
        <div id="step1" class="col-xs-1 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 1</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated %}
          <a href="{% url 'wizard:step1' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Modelo" %}</div>
        </div>

        <div id="step2" class="col-xs-2 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 2</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 1 %}
          <a href="{% url 'wizard:step2' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Domínio" %}</div>
        </div>

        <div id="step3" class="col-xs-2 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 3</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 2 %}
          <a href="{% url 'wizard:step3' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Fronteiras" %}</div>
        </div>

        <div id="step4" class="col-xs-1 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 4</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 3 %}
          <a href="{% url 'wizard:step4' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Estações" %}</div>
        </div>

        <div id="step5" class="col-xs-1 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 5</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 4 %}
          <a href="{% url 'wizard:step5' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Parâmetros Hidrodinâmicos" %}</div>
        </div>

        <div id="step6" class="col-xs-2 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 6</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 5 %}
          <a href="{% url 'wizard:step6' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Dados adicionais" %}</div>
        </div>

        <div id="step7" class="col-xs-2 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 7</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 6 %}
          <a href="{% url 'wizard:step7' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Qualidade da Água" %}</div>
        </div>

        <div id="step8" class="col-xs-1 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 8</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 7 %}
          <a href="{% url 'wizard:step8' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Submissão" %}</div>
        </div>
    </div>

{% endblock content %}